/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.java.html.canvas;

import java.awt.Dimension;

/**
 *
 * @author antonepple
 */
public interface GraphicsEnvironment {
    public void arc(double centerX,
            double centerY,
            double startAngle,
            double radius,
            double endAngle,
            boolean ccw);

    public void arcTo(double x1,
            double y1,
            double x2,
            double y2,
            double r);

    public boolean isPointInPath(double x, double y);

    public void fill();

    public void stroke();

    public void beginPath();

    public void closePath();

    public void clip();

    public void moveTo(double x, double y);

    public void lineTo(double x, double y);

    public void quadraticCurveTo(double cpx, double cpy, double x, double y);

    public void bezierCurveTo(double cp1x, double cp1y, double cp2x, double cp2y, double x, double y);

    public void fillRect(double x, double y, double width, double height);

    public void strokeRect(double x, double y, double width, double height);

    public void clearRect(double x, double y, double width, double height);

    public void rect(double x, double y, double width, double height);

    public void save();

    public void restore();

    public void rotate(double angle);

    public void transform(double a, double b, double c, double d, double e, double f);

    public void setTransform(double a, double b, double c, double d, double e, double f);

    public void translate(double x, double y);

    public void scale(double x, double y);

    public void drawImage(ImageData image, double x, double y);

    public void drawImage(ImageData image, double x, double y, double width, double height);

    public void drawImage(ImageData image, double sx, double sy, double sWidth, double sHeight, double x, double y, double width, double height);

    public void setFillStyle(String style);

    public String getFillStyle();

    public void setFillStyle(Pattern style);

    public void setStrokeStyle(String style);

    public void setStrokeStyle(Pattern style);

    public void setShadowColor(String color);

    public void setShadowBlur(double blur);

    public void setShadowOffsetX(double x);

    public void setShadowOffsetY(double y);

    public String getStrokeStyle();

    public String getShadowColor();

    public double getShadowBlur();

    public double getShadowOffsetX();

    public double getShadowOffsetY();

    public String getLineCap();

    public void setLineCap(String style);

    public String getLineJoin();

    public void setLineJoin(String style);

    public double getLineWidth();

    public void setLineWidth(double width);

    public double getMiterLimit();

    public void setMiterLimit(double limit);

    public String getFont();

    public void setFont(String font);

    public String getTextAlign();

    public void setTextAlign(String textAlign);

    public String getTextBaseline();

    public void setTextBaseline(String textbaseline);

    public void fillText(String text, double x, double y);

    public void fillText(String text, double x, double y, double maxWidth);

    public Dimension measureText(String text);

    public void strokeText(String text, double x, double y);

    public void strokeText(String text, double x, double y, double maxWidth);

    public ImageData createImageData(double x, double y);

    public ImageData createImageData(ImageData imageData);

    public ImageData getImageData(double x, double y, double width, double height);

    public void putImageData(ImageData imageData, double x, double y);

    public void putImageData(ImageData imageData, double x, double y, double dirtyx, double dirtyy, double dirtywidth, double dirtyheight);

    public void setGlobalAlpha(double alpha);

    public double getGlobalAlpha();

    public void setGlobalCompositeOperation(String operation);

    public String getGlobalCompositeOperation();

    public LinearGradient createLinearGradient(double x0, double y0, double x1, double y1);

    public Pattern createPattern(ImageData image, String repeat);

    public RadialGradient createRadialGradient(double x0, double y0, double r0, double x1, double y1, double r1);
    
    public ImageData getImageForPath(String path);
    
    public int getHeight();

    public int getWidth();

    public void setHeight(int height);

    public void setWidth(int width);
    
}
